 '-----------------------------------------------------------------
 '              A S C I I _ T A B
 '-----------------------------------------------------------------
 ' Input files: AsciiCodes.scn
 ' Process: Conversion from DOS format to WIN32 console format.
 '          The conversion is processed by an INLINE ASM SUB.
 ' Output: Display screen AsciiCodes.scn on the WIN32 console
 '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 ' Date: 22-apr-2010
 ' Language: PB/CC 5.04
 ' Author: frktons @ MASM32 Forum
 '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


 #INCLUDE "win32api.inc"


 DECLARE SUB ReadForm(BYVAL location AS LONG)

 DECLARE SUB GetScreen



 FUNCTION PBMAIN()

   GLOBAL FileName AS STRING, MainStr AS STRING, sBuf AS STRING

   CONSOLE SCREEN 25,80

   FileName = "AsciiCodes.scn"

   CALL ReadForm(1)
   CALL GetScreen

   WAITKEY$

 exit_pgm:

 END FUNCTION


'--------------------------------------------------------------------------------
' GetScreen: convert and display the screen in WIN32 console
'--------------------------------------------------------------------------------

 SUB GetScreen

    #REGISTER NONE
    LOCAL lpReadRegion AS SMALL_RECT
    LOCAL SIZE AS DWORD

    DIM y AS STRING PTR, y1 AS STRING PTR
    sBuf = SPACE$(8000)

    y = STRPTR(MainStr)
    y1 = STRPTR(sBuf)

'---------------------------------
' Converted routine
'---------------------------------
'    FOR x = 1 TO 8000 STEP 2
'      POKE y1, PEEK(y)
'      y = y + 1
'      y1 = y1 + 2
'    NEXT x
'---------------------------------
    ! push ebx
    ! push esi
    ! push edi
    ! push eax

    ! mov ebx, 1000
    ! mov esi, y
    ! mov edi, y1
    Convert:
    ! mov eax, [esi]
    ! mov [edi], al
    ! mov [edi+2], ah
    ! bswap eax
    ! mov [edi+6], al
    ! mov [edi+4], ah
    ! add esi, 4
    ! add edi, 8
    ! dec ebx
    ! jnz Convert

    ! pop eax
    ! pop edi
    ! pop esi
    ! pop ebx

    SIZE = MAKDWD(80, 25)
    lpReadRegion.xRight = 79
    lpReadRegion.xBottom = 24
    WriteConsoleOutPut GetStdHandle(%STD_OUTPUT_HANDLE), _
    BYVAL STRPTR(sBuf),BYVAL SIZE, BYVAL 0&, lpReadRegion
 END SUB

'--------------------------------------------------------------------------------
' We read DOS format screen into string variable MainStr
'--------------------------------------------------------------------------------

 SUB ReadForm(BYVAL location AS LONG)
    LOCAL ff AS LONG
    ff = FREEFILE
    OPEN FileName FOR BINARY AS #ff
      SEEK ff, location
      GET$ #ff, 4000, MainStr
    CLOSE #ff

 END SUB
